package repository

import (
	"fmt"
	"strings"
	"time"

	"nms_nbi/src/framework/datasource"
	"nms_nbi/src/framework/logger"
	"nms_nbi/src/framework/utils/parse"
	"nms_nbi/src/framework/utils/repo"
	"nms_nbi/src/modules/network_element/model"
)

// 实例化数据层 NewNeVersion 结构体
var NewNeVersionImpl = &NeVersionImpl{
	selectSql: `select 
	id, ne_type, ne_id, version, file_path, pre_version, pre_file, new_version, new_file, status, update_time
	from ne_version`,

	resultMap: map[string]string{
		"id":          "ID",
		"ne_type":     "NeType",
		"ne_id":       "NeId",
		"version":     "Version",
		"file_path":   "FilePath",
		"pre_version": "PreVersion",
		"pre_file":    "PreFile",
		"new_version": "NewVersion",
		"new_file":    "NewFile",
		"status":      "Status",
		"update_time": "UpdateTime",
	},
}

// NeVersionImpl 网元版本信息 数据层处理
type NeVersionImpl struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *NeVersionImpl) convertResultRows(rows []map[string]any) []model.NeVersion {
	arr := make([]model.NeVersion, 0)
	for _, row := range rows {
		item := model.NeVersion{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// SelectPage 根据条件分页查询字典类型
func (r *NeVersionImpl) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["neType"]; ok && v != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["neId"]; ok && v != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["version"]; ok && v != "" {
		conditions = append(conditions, "version like concat(?, '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["filePath"]; ok && v != "" {
		conditions = append(conditions, "file_path like concat(?, '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.NeHost{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(1) as 'total' from ne_version"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 查询数据
	querySql := r.selectSql + whereSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return result
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *NeVersionImpl) SelectList(neVersion model.NeVersion) []model.NeVersion {
	// 查询条件拼接
	var conditions []string
	var params []any
	if neVersion.NeType != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, neVersion.NeType)
	}
	if neVersion.NeId != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, neVersion.NeId)
	}
	if neVersion.Version != "" {
		conditions = append(conditions, "version like concat(?, '%')")
		params = append(params, neVersion.Version)
	}
	if neVersion.FilePath != "" {
		conditions = append(conditions, "file_path like concat(?, '%')")
		params = append(params, neVersion.FilePath)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by update_time asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIds 通过ID查询
func (r *NeVersionImpl) SelectByIds(cmdIds []string) []model.NeVersion {
	placeholder := repo.KeyPlaceholderByQuery(len(cmdIds))
	querySql := r.selectSql + " where id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(cmdIds)
	results, err := datasource.RawDB("", querySql, parameters)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return []model.NeVersion{}
	}
	// 转换实体
	return r.convertResultRows(results)
}

// CheckUniqueTypeAndID 校验网元类型和网元ID是否唯一
func (r *NeVersionImpl) CheckUniqueTypeAndID(neVersion model.NeVersion) string {
	// 查询条件拼接
	var conditions []string
	var params []any
	if neVersion.NeType != "" {
		conditions = append(conditions, "ne_type = ?")
		params = append(params, neVersion.NeType)
	}
	if neVersion.NeId != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, neVersion.NeId)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	} else {
		return ""
	}

	// 查询数据
	querySql := "select id as 'str' from ne_version " + whereSql + " limit 1"
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err %v", err)
		return ""
	}
	if len(results) > 0 {
		return fmt.Sprint(results[0]["str"])
	}
	return ""
}

// Insert 新增信息
func (r *NeVersionImpl) Insert(neVersion model.NeVersion) string {
	// 参数拼接
	params := make(map[string]any)
	if neVersion.NeType != "" {
		params["ne_type"] = neVersion.NeType
	}
	if neVersion.NeId != "" {
		params["ne_id"] = neVersion.NeId
	}
	if neVersion.Version != "" {
		params["version"] = neVersion.Version
	}
	if neVersion.FilePath != "" {
		params["file_path"] = neVersion.FilePath
	}
	if neVersion.PreVersion != "" {
		params["pre_version"] = neVersion.PreVersion
	}
	if neVersion.PreFile != "" {
		params["pre_file"] = neVersion.PreFile
	}
	if neVersion.NewVersion != "" {
		params["new_version"] = neVersion.NewVersion
	}
	if neVersion.NewFile != "" {
		params["new_file"] = neVersion.NewFile
	}
	if neVersion.Status != "" {
		params["status"] = neVersion.Status
	}
	params["update_time"] = time.Now()

	// 构建执行语句
	keys, placeholder, values := repo.KeyPlaceholderValueByInsert(params)
	sql := "insert into ne_version (" + strings.Join(keys, ",") + ")values(" + placeholder + ")"

	db := datasource.DefaultDB()
	// 开启事务
	tx := db.Begin()
	// 执行插入
	err := tx.Exec(sql, values...).Error
	if err != nil {
		logger.Errorf("insert row : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 获取生成的自增 ID
	var insertedID string
	err = tx.Raw("select last_insert_id()").Row().Scan(&insertedID)
	if err != nil {
		logger.Errorf("insert last id : %v", err.Error())
		tx.Rollback()
		return ""
	}
	// 提交事务
	tx.Commit()
	return insertedID
}

// Update 修改信息
func (r *NeVersionImpl) Update(neVersion model.NeVersion) int64 {
	// 参数拼接
	params := make(map[string]any)
	if neVersion.NeType != "" {
		params["ne_type"] = neVersion.NeType
	}
	if neVersion.NeId != "" {
		params["ne_id"] = neVersion.NeId
	}
	if neVersion.Version != "" {
		params["version"] = neVersion.Version
	}
	if neVersion.FilePath != "" {
		params["file_path"] = neVersion.FilePath
	}
	if neVersion.PreVersion != "" {
		params["pre_version"] = neVersion.PreVersion
	}
	if neVersion.PreFile != "" {
		params["pre_file"] = neVersion.PreFile
	}
	if neVersion.NewVersion != "" {
		params["new_version"] = neVersion.NewVersion
	}
	if neVersion.NewFile != "" {
		params["new_file"] = neVersion.NewFile
	}
	if neVersion.Status != "" {
		params["status"] = neVersion.Status
	}
	params["update_time"] = time.Now()

	// 构建执行语句
	keys, values := repo.KeyValueByUpdate(params)
	sql := "update ne_version set " + strings.Join(keys, ",") + " where id = ?"

	// 执行更新
	values = append(values, neVersion.ID)
	rows, err := datasource.ExecDB("", sql, values)
	if err != nil {
		logger.Errorf("update row : %v", err.Error())
		return 0
	}
	return rows
}

// DeleteByIds 批量删除信息
func (r *NeVersionImpl) DeleteByIds(cmdIds []string) int64 {
	placeholder := repo.KeyPlaceholderByQuery(len(cmdIds))
	sql := "delete from ne_version where id in (" + placeholder + ")"
	parameters := repo.ConvertIdsSlice(cmdIds)
	results, err := datasource.ExecDB("", sql, parameters)
	if err != nil {
		logger.Errorf("delete err => %v", err)
		return 0
	}
	return results
}
